sampler2D img;
int width, height;
float alpha;

float4x4 ptn1 = { 0, 0, 0, 0,
		  0, 0, 1, 0,
		  0, 0, 0, 0,
		  1, 0, 0, 0 };

float4x4 ptn2 = { 1, 0, 1, 0,
		  0, 0, 0, 0,
		  1, 0, 1, 0,
		  0, 0, 0, 0 };

float4x4 ptn3 = { 0, 0, 1, 0,
		  0, 1, 0, 1,
		  1, 0, 0, 0,
		  0, 1, 0, 1 };

float4x4 ptn5 = { 1, 1, 0, 1,
		  1, 0, 1, 0,
		  0, 1, 1, 1,
		  1, 0, 1, 0 };

float4x4 ptn6 = { 0, 1, 0, 1,
		  1, 1, 1, 1,
		  0, 1, 0, 1,
		  1, 1, 1, 1 };

float4x4 ptn7 = { 1, 1, 1, 1,
		  1, 1, 0, 1,
		  1, 1, 1, 1,
		  0, 1, 1, 1 };


float4 ps_main(in float2 In : TEXCOORD0) : COLOR0	{
	float4 pixel = tex2D(img,In);
	float xIn = (In.x * width) % 4;
	float yIn = (In.y * height) % 4;
	float pattern = round(pixel.a * alpha * 8.0);
	pixel.a = 1;
	if (pattern == 0) { pixel.a = 0; }
	if (pattern == 1) { pixel.a = ptn1[xIn][yIn]; }
	if (pattern == 2) { pixel.a = ptn2[xIn][yIn]; }
	if (pattern == 3) { pixel.a = ptn3[xIn][yIn]; }
	if (pattern == 4) { pixel.a = abs(((xIn % 2) - (yIn % 2))); }
	if (pattern == 5) { pixel.a = ptn5[xIn][yIn]; }
	if (pattern == 6) { pixel.a = ptn6[xIn][yIn]; }
	if (pattern == 7) { pixel.a = ptn7[xIn][yIn]; }

	return pixel;
}

technique tech_main	{ pass P0 { PixelShader = compile ps_2_a ps_main(); }  }